*! version 0.2.0 2012-08-27 | long freese | replace rm_lincomstats

**  compute statistics from lincom returns
**
**  after lincom, just run: _rm_lincom_stats

capture program drop _rm_lincom_stats
program define _rm_lincom_stats, rclass

    tempname estval seval levelval levelpval cifactorval zval pval lbval ubval

    scalar `estval'     = r(estimate) // lincom estimate
    scalar `seval'      = r(se) // lincom std err
    scalar `zval'       = `estval'/`seval' // zvalue
    scalar `pval'       = 2*(1-normal(abs(`zval'))) // pvalue 2 tailed
    scalar `levelval'   = $S_level // level for CI
    scalar `levelpval'  = ( 1 - (`levelval'/100) )/2 // pval for ci
    scalar `cifactorval' =  abs(invnormal(`levelpval')) // +- multiplier for ci
    scalar `lbval'      = `estval' - (`cifactorval'*`seval') // lb
    scalar `ubval'      = `estval' + (`cifactorval'*`seval') // ub

    return scalar est   = `estval'
    return scalar se    = `seval'
    return scalar z     = `zval'
    return scalar p     = `pval'
    return scalar lb    = `lbval'
    return scalar ub    = `ubval'
    return scalar level = `levelval'

end

exit

* version 0.1.0 scott long 2012-06-19 09:32:53
* version 0.1.1 scott long 2012-06-20 changed name to mp_lincom
* version 0.1.2 2012-08-08 scott long changed name to mp_lincomstats
* version 0.1.3 2 2012-08-08 scott long changed name to mp_lincomstats
* version 0.1.4 2012-08-27 jsl | move to _rm_lincom_stats | posted
